---
title: Document.requestStorageAccess()
slug: Web/API/Document/requestStorageAccess
tags:
  - API
  - DOM
  - Document
  - Method
  - Reference
  - Storage Access API
  - requestStorageAccess
---
<div>{{APIRef}}</div>

<p>The <strong><code>requestStorageAccess()</code></strong> method of the {{domxref("Document")}} interface returns a {{jsxref("Promise")}} that resolves if the access to first-party storage was granted, and rejects if access was denied.</p>

<h2 id="Conditions_for_granting_storage_access">Conditions for granting storage access</h2>

<p>Storage access is granted based on a series of checks described here:</p>

<ol>
 <li>If the document already has been granted access, resolve.</li>
 <li>If the document has a null origin, reject.</li>
 <li>If the document's frame is the main frame, resolve.</li>
 <li>If the sub frame's origin is equal to the main frame's, resolve.</li>
 <li>If the sub frame is not sandboxed, skip to step 7.</li>
 <li>If the sub frame doesn't have the token <code>allow-storage-access-by-user-activation</code>, reject.</li>
 <li>If the sub frame's parent frame is not the top frame, reject.</li>
 <li>If the browser is not processing a user gesture, reject.</li>
 <li>Check any additional rules that the browser has. Examples: allow lists, block lists, on-device classification, user settings, anti-clickjacking heuristics, or prompting the user for explicit permission. Reject if some rule is not fulfilled.</li>
 <li>Grant the document access to cookies and other site storage and store that fact for the purposes of future calls to {{domxref("Document.hasStorageAccess()")}} and <code>requestStorageAccess()</code>.</li>
</ol>

<p>Assuming all of the requirements above are satisfied, Firefox will automatically grant storage access to the requesting origin on up to a threshold number of first-party origins in the current session for the duration of user’s session, up to a maximum of 24 hours. After the requesting origin has exceeded the maximum allowable number of storage access grants, any future call to <code>requestStorageAccess()</code> during the same browsing session will prompt the user.</p>

<p>The maximum number of concurrent storage access grants an origin can obtain is a positive integer currently defined as one percent of the number of top-level origins visited in the current session or 5, whichever is higher. The threshold is enforced on the level of eTLD+1, so for example two storage access grants for <code>foo.example.com</code> and <code>bar.example.com</code> will only count as a single exception against the limit.</p>

<p>At the time of a <code>requestStorageAccess()</code> call, if the requesting origin has storage access to...</p>

<p>...fewer origins than the maximum:</p>

<ul>
 <li>The user is not prompted.</li>
 <li>The origin is given an ephemeral storage access grant for the current top-level origin.</li>
 <li>The number of origins the requesting origin has storage access to is incremented by one.
  <ul>
   <li>Note that this number is also incremented when automatic access grants are given through <a href="/en-US/docs/Mozilla/Firefox/Privacy/Storage_access_policy#Automatic_storage_access_upon_interaction">our compatibility heuristics</a>.</li>
  </ul>
 </li>
 <li>The ephemeral storage access grant is:
  <ul>
   <li>Invalidated at the end of the browser session.</li>
   <li>Not persisted to disk (e.g. will not persist if the browser crashes).</li>
   <li>Reset after 24 hours in the case of a long-running browser session.</li>
  </ul>
 </li>
</ul>

<p>...equal or more origins than the maximum:</p>

<ul>
 <li>The user is prompted</li>
 <li>If the user clicks “Allow” or “Allow on any site” the request is resolved.</li>
 <li>If the user clicks “Don’t Allow”, the storage access request is rejected and the requesting origin can re-request once it receives another user interaction.</li>
 <li>If the user allows storage the requesting origin is given a persistent storage access grant on the current top-level origin.</li>
 <li>The number of origins the requesting origin has storage access to is incremented by one.</li>
 <li>The persistent storage access permission is:
  <ul>
   <li>Persisted to disk and will remain valid in future browser sessions.</li>
   <li>Reset after 30 days.</li>
  </ul>
 </li>
</ul>

<p>When an ephemeral or persistent storage access grant expires, the number of origins the requesting origin has storage access to is decremented by one.</p>

<div class="notecard note">
<p><strong>Note</strong>: If the requesting origin is not <a href="/en-US/docs/Mozilla/Firefox/Privacy/Storage_access_policy#Tracking_protection_explained">classified as a tracking origin</a>, the access request is automatically given an ephemeral storage access grant, which will go away when the page is reloaded. The user is never shown a prompt in this case, and calling <code>requestStorageAccess()</code> won’t have any side effects besides changing the value returned by {{domxref("Document.hasStorageAccess()")}}.</p>
</div>

<h2 id="Debugging">Debugging</h2>

<p>The storage access grant threshold may make it more difficult to test your website under the condition where Firefox prompts the user for access. To make testing easier, we have added two preferences in <code>about:config</code> that control prompting upon <code>requestStorageAccess()</code> calls:</p>

<ul>
 <li><code>dom.storage_access.auto_grants</code> can be set to <code>false</code> to disable the automatic granting of ephemeral storage access grants. All calls to <code>requestStorageAccess()</code> by origins classified as trackers will trigger a prompt.</li>
 <li><code>dom.storage_access.max_concurrent_auto_grants</code> controls the threshold number of storage access grants at which users will begin to receive prompts. For example, if you want to configure Firefox to automatically grant access on the first site where <code>requestStorageAccess()</code> is called and then prompt afterwards, you should adjust the value of the <code>dom.storage_access.max_concurrent_auto_grants</code> preference to 1.</li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>promise</em> = document.requestStorageAccess();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that fulfills with <code>undefined</code> if the access to first-party storage was granted, and rejects if access was denied.</p>

<p>When the promise gets resolved, the resolve handler will run as if a user gesture is being processed, whether the promise was fulfilled or rejected:</p>

<ul>
 <li>In the former case, code can then start to call APIs that require user activation and things can move forward.</li>
 <li>In the latter case, code can run to inform the user of why the request failed and what they can do to continue (for example asking them to log in, if that is a requirement).</li>
</ul>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">document.requestStorageAccess().then(
  () =&gt; { console.log('access granted') },
  () =&gt; { console.log('access denied') }
);</pre>

<h2 id="Specifications">Specifications</h2>

<p>The API is currently only at the proposal stage — the standardization process has yet to begin. You can currently find specification details of the API at Apple's <a href="https://webkit.org/blog/8124/introducing-storage-access-api/">Introducing Storage Access API</a> blog post, and the <a href="https://github.com/privacycg/storage-access">Storage Access API proposal in the Privacy CG</a>.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.requestStorageAccess")}}</p>

<h2 id="See_also">See also</h2>

<p><a href="/en-US/docs/Web/API/Storage_Access_API">Storage Access API</a></p>
